SystemOrganization addCategory: #'Rizel-Tools'!

Object subclass: #RizelAbstractModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RizelAbstractModel methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 13:15'!
buildBenchmarks
	
	^ (self class allSelectors select: [ :k | k beginsWith: 'bench'  ])
			 collect: [ :k | k -> [self perform: k ]].! !

!RizelAbstractModel methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 13:01'!
configurationClass
	^ self subclassResponsability.! !

!RizelAbstractModel methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 13:05'!
executeBenchmark: aSymbol
	^ self perform: aSymbol.! !

!RizelAbstractModel methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 13:05'!
loadVersion: version
	version load.! !

!RizelAbstractModel methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 13:26'!
open
	|browser|
	browser := Rizel new.
	browser model: self.
	browser benchmarks: (self buildBenchmarks).
	browser openWithSpec.
	^ browser.! !

RizelAbstractModel subclass: #RizelXMLSupportModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RizelXMLSupportModel methodsFor: 'bench' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 13:11'!
addressBookXML
	^'<addressbook>
  <person employee-number="A0000" family-name="Gates" first-name="Bob">
    <contact-info><!!--Confidential--></contact-info>
    <address city="Los Angeles" number="1239" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Manager"/>
    <manager employee-number="A0000"/>
  </person>
  <person employee-number="A7000" family-name="Brown"
    first-name="Robert" middle-initial="L.">
    <contact-info>
      <email address="robb@iro.ibm.com"/>
      <home-phone number="03-3987873"/>
    </contact-info>
    <address city="New York" number="344" state="NY" street="118 St."/>
    <job-info employee-type="Full-Time" is-manager="yes" job-description="Group Leader"/>
    <manager employee-number="A0000"/>
  </person>
  <person employee-number="A7890" family-name="DePaiva"
    first-name="Kassie" middle-initial="W.">
    <contact-info><!!-- Kassie''s agent phone: 03-987654 --></contact-info>
    <address city="Los Angeles" number="1234" state="CA" street="Pine Rd."/>
    <job-info employee-type="Full-Time" is-manager="no" job-description="Actor"/>
    <manager employee-number="A0000"/>
    <misc-info>One of the most talented actresses on Daytime. Kassie
      plays the devious and beautiful Blair Cramer on ABC&apos;s
      &quot;One Life To Live.&quot;</misc-info>
  </person>
  <person employee-number="A7987" family-name="Smith" first-name="Joe">
    <contact-info>
      <email address="joes@iro.ibm.com"/>
      <mobile-phone number="888-7657765"/>
      <home-phone number="03-8767898"/>
      <home-phone number="03-8767871"/>
    </contact-info>
    <address city="New York" number="12789" state="NY" street="W. 15th Ave."/>
    <job-info employee-type="Part-Time" is-manager="no" job-description="Hacker"/>
    <manager employee-number="A7000"/>
  </person>
</addressbook>
'! !

!RizelXMLSupportModel methodsFor: 'bench' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 13:11'!
benchDOMParser
	10 timesRepeat: [XMLDOMParser parse: self addressBookXML]! !

!RizelXMLSupportModel methodsFor: 'bench' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 13:11'!
benchSAXHandler
	10 timesRepeat: [SAXHandler parse: self addressBookXML]! !

!RizelXMLSupportModel methodsFor: 'rizel' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 13:04'!
configurationClass 
	^ ConfigurationOfXMLSupport! !

ComposableModel subclass: #BenchmarkBrowser
	instanceVariableNames: 'classes methods code selectedClass selectedSelector browser ok cancel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!BenchmarkBrowser class methodsFor: 'specs' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:42'!
defaultSpec
	""
	^ { #ComposableSpec.
				#add:. {{#model. #classes. #defaultSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0@0 corner: 0.5@0.5). (0@0 corner: 0@0)}}.
				#add:. {{#model. #methods. #defaultSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0.5@0 corner: 1@0.5). (0@0 corner: 0@0)}}.
				#add:. {{#model. #code. #defaultSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0@0.5 corner: 1@1). (0@0 corner: 0@25)}}.
				"ok"
				#add:. {{#model. #ok. #defaultSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (1@1 corner: 1@1). ((-100)@(-25) corner: -50@0)}}.
				"cancel"
				#add:. {{#model. #cancel. #defaultSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (1@1 corner: 1@1). ((-50)@(-25) corner: 0@0)}}. }.! !

!BenchmarkBrowser class methodsFor: 'specs' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:22'!
open
	"
	self open
	"
	|browser|
	browser := BenchmarkBrowser new.
	browser classes: Smalltalk allClasses.
	browser openWithSpec.
	^ browser.! !

!BenchmarkBrowser class methodsFor: 'specs' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:31'!
openOn: owner
	"
	self open
	"
	|browser|
	browser := BenchmarkBrowser new.
	browser classes: Smalltalk allClasses.
	browser browser: owner.
	browser openWithSpec.
	^ browser.! !

!BenchmarkBrowser class methodsFor: 'specs' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:56'!
title
	^ 'Benchmark Browser'! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:30'!
browser 
	^ browser! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:30'!
browser: aBrowser
	""
	browser := aBrowser.! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 13:00'!
cancel
	cancel ifNil:[ 
		cancel := self instantiate: ButtonModel.
		cancel whenActionPerformedDo: [self close].
		cancel label: 'cancel'. ].
	^ cancel.! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:59'!
classes
	^ classes! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 00:00'!
classes: aCollection
	classes items: aCollection.! !

!BenchmarkBrowser methodsFor: 'specs' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:56'!
close
	self delete.
	! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:59'!
code
	^ code! !

!BenchmarkBrowser methodsFor: 'specs' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:25'!
initializeWidgets
	""
	classes := self instantiate: IconListModel.
	classes whenSelectedItemChanged: [ :selected |
		selected ifNotNilDo: [ :cls |
			selectedClass  := cls.
			self methods: ((cls methodDict values sort: [:a :b | a selector < b selector]) )]. ].
	methods := self instantiate: IconListModel.
	methods whenSelectedItemChanged: [:selected|
		selected ifNotNilDo: [ :m |
			selectedSelector := m.
			code text: (m sourceCode) ]. ].
	methods displayBlock: [:m| m selector].
	code := self instantiate: TextModel.! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:59'!
methods
	^ methods! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 00:16'!
methods: aCollection
	methods items: aCollection.! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 12:01'!
ok
	ok ifNil:[ 
		ok := self instantiate: ButtonModel.
		ok label: 'Ok'.
		ok whenActionPerformedDo:[
			(selectedClass notNil and:[ selectedSelector notNil]) 
			ifTrue: [ browser addBench: 
				( (selectedSelector methodReference)
					-> [
						(selectedClass new 
							setTestSelector: (selectedSelector asSymbol)) run]).].
			self close.].
		 ].
	^ ok.! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:23'!
selectedBenchClass 
	^ selectedClass! !

!BenchmarkBrowser methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:23'!
selectedBenchSelector
	^ selectedSelector! !

ComposableModel subclass: #Rizel
	instanceVariableNames: 'versions benchmarks model options roassal benchs morphView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!Rizel class methodsFor: 'spec' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 11:40'!
defaultSpec
	""
	^ { #ComposableSpec.
				#add:. {{#model. #versions. #defaultSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0@0.5 corner: 0.3@1). (0@0 corner: 0@0)}}.
				#add:. {{#model. #benchmarks. #defaultSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0@0 corner: 0.3@0.5). (0@25 corner: 0@0)}}.
				#add:. {{#model. #options. #defaultSpec.}.
				#layout:. {#FrameLayout.
				#fractions:offsets:. (0@0 corner: 0.3@0). (0@0 corner: 0@25)}}.
				"morph"
				#add:. {{#model. #roassal. #defaultSpec.}.
				#layout:. {#FrameLayout.
					#fractions:offsets:. (0.3@0 corner: 1@1). (0@0 corner: 0@0)}}.}.! !

!Rizel class methodsFor: 'spec' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:12'!
openWith: aConfiguration
	|browser|
	browser := Rizel new.
	browser configurationModel: aConfiguration.
	browser openWithSpec.
	^ browser.! !

!Rizel class methodsFor: 'spec' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:24'!
title
	^ 'Rizel'! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 13:05'!
addBench: anAssociation
	""
	benchs add: anAssociation.
	self benchmarks: benchs.! !

!Rizel methodsFor: 'action' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 13:01'!
addBenchmark
	""
	BenchmarkBrowser openOn: self.! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:07'!
benchmarks
	^ benchmarks! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 13:04'!
benchmarks: aList
	self benchmarks items: aList.! !

!Rizel methodsFor: 'action' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 01:03'!
compare! !

!Rizel methodsFor: 'initialization' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:30'!
initialize 
	super initialize.
	benchs  := OrderedCollection new.! !

!Rizel methodsFor: 'initialization' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 11:47'!
initializeWidgets
	versions := self instantiate: ListComposableModel.
	versions displayBlock: [: v| v versionNumber asString].
	versions beMultipleSelection.
	benchmarks := self instantiate: ListComposableModel.
	benchmarks displayBlock: [ :b | b key asString].
	benchmarks beMultipleSelection.
	options := self instantiate: RizelOptions.
	options browser: self.
	roassal := self instantiate: RoassalModel.! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 13:24'!
model: anRizelAbstractModel
	""
	model := anRizelAbstractModel.
	self versions: (((model configurationClass project 
						versions select:[ :v|  v importedVersions size >0]) reversed) asOrderedCollection).! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:07'!
options
	^ options.! !

!Rizel methodsFor: 'action' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 13:26'!
profile
	|builder result|
	builder := RzBuilder new.
	"defining variables and execution context"
	builder define: #input 
			named: #version 	  
			with: (self selectedVersions). 
	builder define: #input 
			named: #benchmark   
			with: (self selectedBenchmarks).
	"automatic execution"
	result := builder execute: [ :version :benchmark |
		[
		model loadVersion: version.
		[ model executeBenchmark: benchmark ] timeToRun.
		] on: Exception do:[ 1 ].
	].
	"visualizing results"
	RzVisualizer2D new
						xValues: (self selectedVersions);
						yValues: (self selectedBenchmarks);
						value: [ :version :bench |  result at: (RzVector <== version+bench)];
						padding: 150;
						visualizeOn: self roassal view.! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 00:55'!
roassal
	^ roassal.! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 01:10'!
selectedBenchmarks
	^ self benchmarks selectedItems collect: [ :assoc | assoc value].! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 01:08'!
selectedVersions
	^ self versions selectedItems.! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:07'!
versions
	^ versions! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:29'!
versions: aCollection
	self versions items: aCollection! !

!Rizel methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 00:55'!
view
	^ roassal view.! !

ComposableModel subclass: #RizelOptions
	instanceVariableNames: 'add profile compare browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RizelOptions class methodsFor: 'specs' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:18'!
defaultSpec
	<spec>
	^ { #Panel.
			#changeTableLayout.
			#listDirection:.		#rightToLeft.
			#addMorph:. {#model.	#add.	#defaultSpec}.
			#addMorph:. {#model.	#profile.	#defaultSpec}.
			#addMorph:. {#model.	#compare.	#defaultSpec}.
			#hResizing:.	#spaceFill.
			#vResizing:.	#shrinkWrap.	}! !

!RizelOptions class methodsFor: 'specs' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:04'!
title
	^ 'Rizel Options'! !

!RizelOptions methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 13:01'!
add
	add ifNil:[
		add := self instantiate: ButtonModel.
		add whenActionPerformedDo: [ browser addBenchmark.].
		add label: '+ bench'.].
	^ add.
! !

!RizelOptions methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:26'!
browser
	^ browser.! !

!RizelOptions methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:27'!
browser: aBrowser
	browser := aBrowser.! !

!RizelOptions methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:16'!
compare
	compare ifNil:[
		compare := self instantiate: ButtonModel.
		compare label: 'Compare'.].
	^ compare.
! !

!RizelOptions methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalAlcocer 8/6/2012 23:05'!
initializeWidgets! !

!RizelOptions methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 01:16'!
profile
	profile ifNil:[
		profile := self instantiate: ButtonModel.
		profile whenActionPerformedDo: [ browser profile.].
		profile label: 'Profile'.].
	^ profile.
! !

!RizelOptions methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:54'!
window
	^ window! !

!RizelOptions methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 8/7/2012 12:55'!
window: aWindow
	""
	window := aWindow.! !

ComposableModel subclass: #RoassalModel
	instanceVariableNames: 'builder container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Tools'!

!RoassalModel class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 11:43'!
defaultSpec

	^ { #ComposableSpec.
			#addMorphWrapper:.	
				{#MorphWrapper.
					#morph:. 		{#model. #container.}.
					#fullFrame:. 	{#LayoutFrame.
						#fractions:offsets:.	 (0@0 corner: 1@1).	(2@2 corner: 2@2). }}.}! !

!RoassalModel class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 00:32'!
title

	^ 'RoassalSpec'! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 00:54'!
container
	
	^ container.! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 11:42'!
initializeWidgets
	"Initialization code for RadioButtonGroupExample"
	builder := ROMondrianViewBuilder new.
	container := ROMorphWidgetFactory forView: builder view.! !

!RoassalModel methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 8/10/2012 01:20'!
view
	
	^ builder.! !
